from ctypes import *
import ctypes
import datetime
import threading

titles = []
MeasureAqcuireTimes = 5

def ReadFromDso():         
    global MeasureAqcuireTimes
    mydll = windll.LoadLibrary("D:\\DSO_Measure\\AqVISA.dll")           #AqVISA.dll Directory
    mydll.viWrite.argtypes = [ctypes.c_char_p]
    mydll.viRead.argtypes = [ctypes.c_char_p, ctypes.c_int]
    if (mydll.viOpenRM(0) == 0):
        print("Error", mydll.viErrCode())
        MeasureAqcuireTimes = 0
    if (mydll.viWrite(ctypes.c_char_p(b"DATA:SOURCE:CH1")) == 0):        #Select Data Source
        MeasureAqcuireTimes = 0
        return
    if (mydll.viWrite(ctypes.c_char_p(b"Measurement:Frequency?")) == 0): #Select Measure Type
        MeasureAqcuireTimes = 0
        return
    ReadBuf = ctypes.create_string_buffer(1024)
    if (mydll.viRead(ReadBuf, 1024) == 0):
        print("Error", mydll.viErrCode())
        MeasureAqcuireTimes = 0
    else:
        print(ReadBuf.value, ", Current Time", datetime.datetime.now())  #Print Result & Time
        MeasureAqcuireTimes = MeasureAqcuireTimes - 1
    mydll.viCloseRM()     
    del mydll
def MeasureTimer():
    global MeasureAqcuireTimes
    ReadFromDso() 
    if (MeasureAqcuireTimes > 0):
        threading.Timer(1.5, MeasureTimer).start()                              #Read Data From DSO Every 1.5 Sec
        
def main():
    """
        -----------
        main method
        -----------
    """    
    MeasureTimer()    


   #end of main
if __name__ == "__main__":
    main()
